unit UnitVideo;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,  Vcl.StdCtrls,
  Vcl.Imaging.pngimage, Vcl.ExtCtrls, PasLibVlcPlayerUnit, Vcl.ComCtrls,
  Trackbarsergio;

type
  TFicheVideo = class(TForm)
    PanelControle: TPanel;
    BoutonPlay: TImage;
    BoutonReculer: TImage;
    BoutonAvancer: TImage;
    BoutonPause: TImage;
    LabelDebut: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    LabelFin: TLabel;
    PleinEcran: TImage;
    SequenceSuivante: TImage;
    SequencePrecedente: TImage;
    FixerDebut: TImage;
    FixerFin: TImage;
    InsererSequence: TImage;
    SupprimerSequence: TImage;
    Edit1: TEdit;
    VlcPlayer: TPasLibVlcPlayer;
    Panel1: TPanel;
    BoutonOuvrirVideo: TImage;
    Diode: TImage;
    LabelTime: TLabel;
    LabelLength: TLabel;
    TrackBarVideo: TTrackBarSerge;
    LabelOuvre: TLabel;
    LabelRecule: TLabel;
    LabelAvance: TLabel;
    LabelMs: TLabel;
    LabelDeb: TLabel;
    LabelF: TLabel;
    LabelInsere: TLabel;
    LabelSuppr: TLabel;
    LabelSuivant: TLabel;
    LabelPrecedent: TLabel;
    LabelTaille: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Bevel1: TBevel;
    PanelMasqueur: TPanel;
    TrackBarVolume: TTrackBarSerge;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BoutonOuvrirVideoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BoutonOuvrirVideoMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BoutonPauseMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VlcPlayerMediaPlayerEndReached(Sender: TObject);
    procedure VlcPlayerMediaPlayerLengthChanged(Sender: TObject; time: Int64);
    procedure VlcPlayerMediaPlayerTimeChanged(Sender: TObject; time: Int64);
    procedure TrackBarVideoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TrackBarVideoMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FixerDebutMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FixerFinMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BoutonPlayMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BoutonReculerMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BoutonAvancerMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure InsererSequenceMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SupprimerSequenceMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SequenceSuivanteMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SequencePrecedenteMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PleinEcranMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PanelMasqueurMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PanelMasqueurMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure TrackBarVolumeChange(Sender: TObject);
    procedure DiodeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DiodeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Dclarations prives }
    BordDroit, PasBord, BordBas, Redim : boolean;
  public
    { Dclarations publiques }
    LeftOrigine,
    TopOrigine,
    WidthOrigine,
    HeightOrigine,
    LeftDefaut,
    TopDefaut,
    WidthDefaut,
    HeightDefaut,
    WidthMax,
    HeightMax  : Integer;

    procedure SimuleAppuiBouton(Sender: TObject);
    procedure SimuleRelachementBouton(Sender: TObject);
    procedure PlacePanelMasqueur;

    function PlayerOk : Boolean;
  end;

var
  FicheVideo: TFicheVideo;

implementation

Uses Unit1;

{$R *.dfm}


procedure TFicheVideo.FormCreate(Sender: TObject);
begin
  // pour pouvoir redimensionner avec la fiche
  VlcPlayer.Align:=alClient;
  // panel masqueur de sous-titres
  // interdire rduction trop importante
  PanelMasqueur.Constraints.MinWidth:=20;
  PanelMasqueur.Constraints.MinHeight:=20;
  // Ne pas mettre de style de bordure
  //PanelMasqueur.BorderStyle:=bsNone;
  // affecte taille max
  WidthMax:=Screen.Width;
  HeightMax:=Screen.Height-30;
end;

procedure TFicheVideo.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=VK_SPACE) and not(Form1.Memo1.Focused) then Form1.PlayPause1Click(Form1);
end;

procedure TFicheVideo.FormResize(Sender: TObject);
begin
  // n'affecte les nouvelles valeurs que si elles diffrent de la taille max
  // sinon, impossible de restituer la taille choisie par l'utilisateur
  // sauve position et taille vido
  if (FicheVideo.Width<WidthMax) and (FicheVideo.Height<HeightMax) then
  begin
    LeftOrigine:=FicheVideo.Left;
    TopOrigine:=FicheVideo.Top;
    WidthOrigine:=FicheVideo.Width;
    HeightOrigine:=FicheVideo.Height;
  end;
end;

procedure TFicheVideo.InsererSequenceMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  Form1.InsererSequence1Click(Form1);
end;

procedure TFicheVideo.BoutonAvancerMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  // avance la vido du contenu d'Edit1 en millisecondes
  if PlayerOk then VlcPlayer.SetVideoPosInMs(VlcPlayer.GetVideoPosInMs+StrToInt(Edit1.Text));
end;

procedure TFicheVideo.BoutonOuvrirVideoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SimuleAppuiBouton((Sender as TImage));
end;

procedure TFicheVideo.BoutonOuvrirVideoMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  Form1.OuvrirVideo1Click(Form1);
end;

procedure TFicheVideo.BoutonPauseMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  Form1.PlayPause1Click(Form1);
end;

procedure TFicheVideo.BoutonPlayMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  Form1.ArretAuto1Click(Form1);
end;

procedure TFicheVideo.BoutonReculerMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  // recule la vido du contenu d'Edit1 en millisecondes
  if PlayerOk then VlcPlayer.SetVideoPosInMs(VlcPlayer.GetVideoPosInMs-StrToInt(Edit1.Text));
end;

procedure TFicheVideo.DiodeMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    SimuleAppuiBouton(BoutonPlay);
end;

procedure TFicheVideo.DiodeMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton(BoutonPlay);
  Form1.ArretAuto1Click(Form1);
end;

procedure TFicheVideo.FixerDebutMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  Form1.Fixerdebut1Click(Form1);
end;

procedure TFicheVideo.FixerFinMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  Form1.Fixerfin1Click(Form1);
end;

procedure TFicheVideo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  VlcPlayer.Stop();
  Form1.Close;
end;

procedure TFicheVideo.SequencePrecedenteMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  Form1.SequencePrecedente1Click(Form1);
end;

procedure TFicheVideo.SequenceSuivanteMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  Form1.SequenceSuivante1Click(Form1);
end;

procedure TFicheVideo.SimuleAppuiBouton(Sender: TObject);
begin
  (Sender as TImage).Left:=(Sender as TImage).Left+3;
  (Sender as TImage).Top:=(Sender as TImage).Top+3;
end;

procedure TFicheVideo.SimuleRelachementBouton(Sender: TObject);
begin
  (Sender as TImage).Left:=(Sender as TImage).Left-3;
  (Sender as TImage).Top:=(Sender as TImage).Top-3;
end;

procedure TFicheVideo.PlacePanelMasqueur;
begin
  FicheVideo.PanelMasqueur.Width:=FicheVideo.ClientWidth;
  FicheVideo.PanelMasqueur.Top:=FicheVideo.Panel1.Top-FicheVideo.PanelMasqueur.Height;
  FicheVideo.PanelMasqueur.Left:=0;
end;

procedure TFicheVideo.SupprimerSequenceMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  Form1.Supprimer1Click(Form1);
end;

procedure TFicheVideo.TrackBarVideoMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if VlcPlayer.CanSeek() then
  begin
    // le tag de la trackbar indique si le lecteur jouait quand on a dplac le curseur (Tag=1)
    if VlcPlayer.GetState() = plvPlayer_Playing then TrackBarVideo.Tag := 1;
    BoutonPause.Tag := 0;
    VlcPlayer.Pause();
    // mode pause
  end;
end;

procedure TFicheVideo.TrackBarVideoMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if VlcPlayer.CanSeek() then
  begin
    VlcPlayer.SetVideoPosInMs(TrackBarVideo.Position);
    LabelTime.Caption := VlcPlayer.GetVideoPosStr('hh:mm:ss,ms');
    // si le player tait en train de jouer, on le relance
    if TrackBarVideo.Tag=1 then
    begin
      BoutonPause.Tag := 1;
      VlcPlayer.Resume();
      TrackBarVideo.Tag:=0;
    end;
  end;
end;

procedure TFicheVideo.TrackBarVolumeChange(Sender: TObject);
begin
  Label7.Caption:=IntToStr(TrackBarVolume.Position);
  Form1.MetVolume;
end;

procedure TFicheVideo.VlcPlayerMediaPlayerEndReached(Sender: TObject);
begin
  LabelTime.Caption := '';
  TrackBarVideo.Position := 0;
end;

procedure TFicheVideo.VlcPlayerMediaPlayerLengthChanged(Sender: TObject;
  time: Int64);
begin
  LabelTime.Caption := VlcPlayer.GetVideoPosStr('hh:mm:ss,ms');
  LabelLength.Caption:=VlcPlayer.GetVideoLenStr('hh:mm:ss,ms');
  TrackBarVideo.Max := VlcPlayer.GetVideoLenInMs();
end;

procedure TFicheVideo.VlcPlayerMediaPlayerTimeChanged(Sender: TObject;
  time: Int64);
var
  Chaine: String;
begin
  Chaine:=LabelTime.Caption;
  Chaine := VlcPlayer.GetVideoPosStr('hh:mm:ss,ms');
  // problme si millisecondes ne font que 2 chiffres (ex: 80) au lieu de 3 (ex: 800)
  // si longueur LabelTime<12 il manque un 0 en dbut de millisecondes -> l'insrer
  if Length(Chaine)<12 then Insert('0',Chaine,10);
  LabelTime.Caption:=Chaine;
  TrackBarVideo.Position := VlcPlayer.GetVideoPosInMs();
end;

// =============== FONCTIONS ==============

procedure TFicheVideo.PanelMasqueurMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  // si bouton enfonc, mmoriser ce qu'il faut faire en fonction ducurseur
  PasBord:=False;
  if PanelMasqueur.Cursor=crHsplit then BordDroit:=True else BordDroit:=False;
  if PanelMasqueur.Cursor=crVsplit then BordBas:=True else BordBas:=False;
  if PanelMasqueur.Cursor=crDrag then PasBord:=True else PasBord:=False;
  if PanelMasqueur.Cursor=crSizeAll then Redim:=True else Redim:=False;
  if PasBord then // dplacement
  begin
    ReleaseCapture;
    PanelMasqueur.Perform(WM_SYSCOMMAND, $F012, 0);
  end;
end;

procedure TFicheVideo.PanelMasqueurMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  // changer de curseur selon la position (mettre BorderWidth  4 au moins)
  // si on est sur le bord droit
  if (X>=PanelMasqueur.Width-PanelMasqueur.BorderWidth) then PanelMasqueur.Cursor:=crHsplit
  else if (X<PanelMasqueur.Width-PanelMasqueur.BorderWidth) then PanelMasqueur.Cursor:=crDrag;
  // si on est sur le bord infrieur
  if (Y>PanelMasqueur.Height-PanelMasqueur.BorderWidth) then PanelMasqueur.Cursor:=crVsplit;
  // si on est sur le coin infrieur droit (redimensionnement x et y)
  if (X>=PanelMasqueur.Width-PanelMasqueur.BorderWidth)
    and (Y>PanelMasqueur.Height-PanelMasqueur.BorderWidth)
      then PanelMasqueur.Cursor:=crSizeAll;
  if ssleft in shift then
  begin
    if (BordDroit or Redim) then PanelMasqueur.Width:=x;
    if (BordBas or Redim) then PanelMasqueur.Height:=y;
  end;
end;

function TFicheVideo.PlayerOk : Boolean;
begin
  if (VlcPlayer.GetState() = plvPlayer_Playing)
     or (VlcPlayer.GetState() = plvPlayer_Paused)
  then Result:=True else Result:=False;
end;


procedure TFicheVideo.PleinEcranMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SimuleRelachementBouton((Sender as TImage));
  Form1.TailleMax1Click(Form1);
end;

end.
